=== debian/changelog ===
vulkan-tools (1.3.204.0+dfsg1-1) unstable; urgency=medium

  * New upstream release.
  * control: Bump libvulkan-dev build-dep.
  * control: Add pkg-config and wayland-protocols to build-depends.

 -- Timo Aaltonen <tjaalton@debian.org>  Wed, 16 Feb 2022 11:45:04 +0200

vulkan-tools (1.2.198.0+dfsg1-1) unstable; urgency=medium

  * New upstream release.
  * control: Bump libvulkan-dev build-dep.

 -- Timo Aaltonen <tjaalton@debian.org>  Fri, 07 Jan 2022 10:57:09 +0200
