## vulkan-tools 1.3.224.0+dfsg1

=== debian/changelog ===
vulkan-tools (1.3.224.0+dfsg1-1) unstable; urgency=medium

  * New upstream release.
  * control: Bump libvulkan-dev build-dep.

 -- Timo Aaltonen <tjaalton@debian.org>  Thu, 25 Aug 2022 18:36:45 +0300

vulkan-tools (1.3.216.0+dfsg1-1) unstable; urgency=medium

  * New upstream release. (Closes: #1013575)
  * control: Bump libvulkan-dev build-dep.
  * install: Add vkcube-wayland.

 -- Timo Aaltonen <tjaalton@debian.org>  Mon, 04 Jul 2022 12:41:10 +0300
