=== debian/changelog ===
vulkan-tools (1.3.231.1+dfsg1-1) unstable; urgency=medium

  * New upstream release.
  * control: Bump libvulkan-dev build-dep.

 -- Timo Aaltonen <tjaalton@debian.org>  Tue, 08 Nov 2022 11:20:04 +0200
