=== debian/control ===
--- 
+++ 
@@ -4,7 +4,7 @@
 Build-Depends: debhelper-compat (= 12),
  cmake,
  glslang-tools,
- libvulkan-dev (>= 1.3.224.0),
+ libvulkan-dev (>= 1.3.231.1),
  libwayland-dev,
  libx11-dev,
  libxcb1-dev,
