=== debian/watch ===
version=3

opts="repack,uversionmangle=s/$/+dfsg1/,filenamemangle=s/(?:.*?)?sdk[_-]?(\d[\d.]*)\.tar\.gz/vulkan-tools-$1.tar.gz/" \
 https://github.com/KhronosGroup/Vulkan-Tools/tags (?:.*?/)sdk[_-](\d[\d.]*)\.tar\.gz
