## vulkan-tools 1.3.239.0+dfsg1

=== debian/changelog ===
vulkan-tools (1.3.239.0+dfsg1-1) unstable; urgency=medium

  * New upstream release.
  * control: Bump libvulkan-dev build-dep.

 -- Timo Aaltonen <tjaalton@debian.org>  Mon, 06 Feb 2023 15:47:32 +0200

vulkan-tools (1.3.236.0+dfsg1-1) unstable; urgency=medium

  * New upstream release.
  * control: Bump libvulkan-dev build-dep.

 -- Timo Aaltonen <tjaalton@debian.org>  Wed, 18 Jan 2023 12:08:55 +0200
