## vulkan-tools 1.3.250.0+dfsg1

=== debian/changelog ===
vulkan-tools (1.3.250.0+dfsg1-1) unstable; urgency=medium

  * New upstream release.
  * control: Bump libvulkan-dev build-dep.

 -- Timo Aaltonen <tjaalton@debian.org>  Mon, 12 Jun 2023 11:57:28 +0300
